/*
 * This file is generated by jOOQ.
 */
package com.alkemy.sophia.api.sophiamsinvoice.dbmodel.jooq.tables;


import com.alkemy.sophia.api.sophiamsinvoice.dbmodel.jooq.DefaultSchema;
import com.alkemy.sophia.api.sophiamsinvoice.dbmodel.jooq.Indexes;
import com.alkemy.sophia.api.sophiamsinvoice.dbmodel.jooq.Keys;
import com.alkemy.sophia.api.sophiamsinvoice.dbmodel.jooq.tables.records.CcidMetadataDetailsRecord;

import java.math.BigDecimal;
import java.util.Arrays;
import java.util.List;

import javax.annotation.Generated;

import org.jooq.Field;
import org.jooq.ForeignKey;
import org.jooq.Identity;
import org.jooq.Index;
import org.jooq.Name;
import org.jooq.Record;
import org.jooq.Schema;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.UniqueKey;
import org.jooq.impl.DSL;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@Generated(
    value = {
        "http://www.jooq.org",
        "jOOQ version:3.11.9"
    },
    comments = "This class is generated by jOOQ"
)
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class CcidMetadataDetails extends TableImpl<CcidMetadataDetailsRecord> {

    private static final long serialVersionUID = 2036656645;

    /**
     * The reference instance of <code>CCID_METADATA_DETAILS</code>
     */
    public static final CcidMetadataDetails CCID_METADATA_DETAILS = new CcidMetadataDetails();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<CcidMetadataDetailsRecord> getRecordType() {
        return CcidMetadataDetailsRecord.class;
    }

    /**
     * The column <code>CCID_METADATA_DETAILS.ID</code>.
     */
    public final TableField<CcidMetadataDetailsRecord, Long> ID = createField("ID", org.jooq.impl.SQLDataType.BIGINT.nullable(false).identity(true), this, "");

    /**
     * The column <code>CCID_METADATA_DETAILS.SOCIETA</code>.
     */
    public final TableField<CcidMetadataDetailsRecord, String> SOCIETA = createField("SOCIETA", org.jooq.impl.SQLDataType.VARCHAR(150).nullable(false), this, "");

    /**
     * The column <code>CCID_METADATA_DETAILS.IDENTIFICATO_VALORE</code>.
     */
    public final TableField<CcidMetadataDetailsRecord, BigDecimal> IDENTIFICATO_VALORE = createField("IDENTIFICATO_VALORE", org.jooq.impl.SQLDataType.DECIMAL(40, 20).nullable(false), this, "");

    /**
     * The column <code>CCID_METADATA_DETAILS.IDENTIFICATO_UTILIZZAZIONI</code>.
     */
    public final TableField<CcidMetadataDetailsRecord, Long> IDENTIFICATO_UTILIZZAZIONI = createField("IDENTIFICATO_UTILIZZAZIONI", org.jooq.impl.SQLDataType.BIGINT, this, "");

    /**
     * The column <code>CCID_METADATA_DETAILS.PERCENTUALE_IDENTIFICATO_UTILIZZAZIONI</code>.
     */
    public final TableField<CcidMetadataDetailsRecord, BigDecimal> PERCENTUALE_IDENTIFICATO_UTILIZZAZIONI = createField("PERCENTUALE_IDENTIFICATO_UTILIZZAZIONI", org.jooq.impl.SQLDataType.DECIMAL(34, 20), this, "");

    /**
     * The column <code>CCID_METADATA_DETAILS.CLAIM_VALORE</code>.
     */
    public final TableField<CcidMetadataDetailsRecord, BigDecimal> CLAIM_VALORE = createField("CLAIM_VALORE", org.jooq.impl.SQLDataType.DECIMAL(34, 20), this, "");

    /**
     * The column <code>CCID_METADATA_DETAILS.CLAIM_UTILIZZAZIONI</code>.
     */
    public final TableField<CcidMetadataDetailsRecord, Long> CLAIM_UTILIZZAZIONI = createField("CLAIM_UTILIZZAZIONI", org.jooq.impl.SQLDataType.BIGINT, this, "");

    /**
     * The column <code>CCID_METADATA_DETAILS.NON_IDENTIFICATO_VALORE</code>.
     */
    public final TableField<CcidMetadataDetailsRecord, BigDecimal> NON_IDENTIFICATO_VALORE = createField("NON_IDENTIFICATO_VALORE", org.jooq.impl.SQLDataType.DECIMAL(34, 20), this, "");

    /**
     * The column <code>CCID_METADATA_DETAILS.NON_IDENTIFICATO_UTILIZZAZIONI</code>.
     */
    public final TableField<CcidMetadataDetailsRecord, Long> NON_IDENTIFICATO_UTILIZZAZIONI = createField("NON_IDENTIFICATO_UTILIZZAZIONI", org.jooq.impl.SQLDataType.BIGINT, this, "");

    /**
     * The column <code>CCID_METADATA_DETAILS.ID_DSR</code>.
     */
    public final TableField<CcidMetadataDetailsRecord, String> ID_DSR = createField("ID_DSR", org.jooq.impl.SQLDataType.VARCHAR(512).nullable(false), this, "");

    /**
     * Create a <code>CCID_METADATA_DETAILS</code> table reference
     */
    public CcidMetadataDetails() {
        this(DSL.name("CCID_METADATA_DETAILS"), null);
    }

    /**
     * Create an aliased <code>CCID_METADATA_DETAILS</code> table reference
     */
    public CcidMetadataDetails(String alias) {
        this(DSL.name(alias), CCID_METADATA_DETAILS);
    }

    /**
     * Create an aliased <code>CCID_METADATA_DETAILS</code> table reference
     */
    public CcidMetadataDetails(Name alias) {
        this(alias, CCID_METADATA_DETAILS);
    }

    private CcidMetadataDetails(Name alias, Table<CcidMetadataDetailsRecord> aliased) {
        this(alias, aliased, null);
    }

    private CcidMetadataDetails(Name alias, Table<CcidMetadataDetailsRecord> aliased, Field<?>[] parameters) {
        super(alias, null, aliased, parameters, DSL.comment(""));
    }

    public <O extends Record> CcidMetadataDetails(Table<O> child, ForeignKey<O, CcidMetadataDetailsRecord> key) {
        super(child, key, CCID_METADATA_DETAILS);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Schema getSchema() {
        return DefaultSchema.DEFAULT_SCHEMA;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public List<Index> getIndexes() {
        return Arrays.<Index>asList(Indexes.CCID_METADATA_DETAILS_CCID_METADATA_DETAILS_CCID_METADATA_ID_DSR_FK, Indexes.CCID_METADATA_DETAILS_CCID_METADATA_DETAILS_UNIQUE_ID_DSR_SOCIETA_IDX, Indexes.CCID_METADATA_DETAILS_PRIMARY);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Identity<CcidMetadataDetailsRecord, Long> getIdentity() {
        return Keys.IDENTITY_CCID_METADATA_DETAILS;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public UniqueKey<CcidMetadataDetailsRecord> getPrimaryKey() {
        return Keys.KEY_CCID_METADATA_DETAILS_PRIMARY;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public List<UniqueKey<CcidMetadataDetailsRecord>> getKeys() {
        return Arrays.<UniqueKey<CcidMetadataDetailsRecord>>asList(Keys.KEY_CCID_METADATA_DETAILS_PRIMARY, Keys.KEY_CCID_METADATA_DETAILS_CCID_METADATA_DETAILS_UNIQUE_ID_DSR_SOCIETA_IDX);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public CcidMetadataDetails as(String alias) {
        return new CcidMetadataDetails(DSL.name(alias), this);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public CcidMetadataDetails as(Name alias) {
        return new CcidMetadataDetails(alias, this);
    }

    /**
     * Rename this table
     */
    @Override
    public CcidMetadataDetails rename(String name) {
        return new CcidMetadataDetails(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public CcidMetadataDetails rename(Name name) {
        return new CcidMetadataDetails(name, null);
    }
}
